Index: /trunk/.htaccess
===================================================================
--- /trunk/.htaccess	(revision 69)
+++ /trunk/.htaccess	(revision 69)
@@ -0,0 +1,12 @@
+<Files ReadMe.txt>
+  order allow,deny
+  deny from all
+</Files>
+
+RewriteEngine On
+RewriteCond  %{REQUEST_FILENAME}  !-f
+RewriteCond  %{REQUEST_FILENAME}  !-d
+RewriteRule   ^(.*)$ %{CONTEXT_PREFIX}/index.php?$1
+
+#ErrorDocument 403 "index.php?page=403"
+#ErrorDocument 404 "index.php?page=404" 
Index: /trunk/Application/Core.php
===================================================================
--- /trunk/Application/Core.php	(revision 69)
+++ /trunk/Application/Core.php	(revision 69)
@@ -0,0 +1,140 @@
+<?php
+
+$ConfigFileName = dirname(__FILE__).'/../Config/Config.php';
+if(file_exists($ConfigFileName)) include_once($ConfigFileName);
+
+include_once(dirname(__FILE__).'/../Global.php');
+include_once(dirname(__FILE__).'/Version.php');
+include_once(dirname(__FILE__).'/View.php');
+include_once(dirname(__FILE__).'/UpdateTrace.php');
+include_once(dirname(__FILE__).'/DefaultConfig.php');
+
+class Core extends Application
+{
+  var $Pages;
+  var $ShowPage;
+  var $BaseURL;
+
+  function __construct()
+  {
+    parent::__construct();
+    $this->Pages = array();
+    $this->ShowPage = true;
+    $this->BaseURL = $_SERVER['SCRIPT_NAME'];
+    if(substr($this->BaseURL, -10, 10) == '/index.php')
+      $this->BaseURL = substr($this->BaseURL, 0, -10);
+  }
+
+  function RunCommon()
+  {
+    global $Config, $DatabaseRevision;
+
+    session_start();
+
+    $ErrorHandler = new ErrorHandler();
+    $ErrorHandler->ShowError = $Config['Web']['ShowError'];
+    $ErrorHandler->Start();
+
+    $this->Database = new Database();
+    $this->Database->Connect($Config['Database']['Host'], $Config['Database']['User'],
+      $Config['Database']['Password'], $Config['Database']['Database']);
+    $this->Database->Prefix = $Config['Database']['Prefix'];
+    $this->Database->charset($Config['Database']['Charset']);
+    $this->Database->ShowSQLError = $Config['Web']['ShowSQLError'];
+    $this->Database->ShowSQLQuery = $Config['Web']['ShowSQLQuery'];
+
+    // SQL injection hack protection
+    foreach($_POST as $Index => $Item) $_POST[$Index] = addslashes($Item);
+    foreach($_GET as $Index => $Item) $_GET[$Index] = addslashes($Item);
+
+    $this->Config = &$Config;
+
+    // Register and start existing modules
+    $this->Setup = new Setup($this);
+    $this->Setup->Start();
+    if($this->Setup->CheckState())
+    {
+      $this->ModuleManager->Start();
+    }
+  }
+
+  function Run()
+  {
+    $this->RunCommon();
+    if($this->ShowPage)
+    {
+      $this->PathItems = ProcessURL();
+      $this->ShowPage();
+    }
+  }
+
+  function ShowPage()
+  {
+    $this->BaseView = new BaseView($this);
+
+    /* @var $Page Page */
+    $ClassName = $this->SearchPage($this->PathItems, $this->Pages);
+    if($ClassName != '')
+    {
+      $Page = new $ClassName($this);
+    } else {
+      $Page = new PageMissing($this);
+    }
+    echo($this->BaseView->GetOutput($Page));
+  }
+
+  function RegisterPage($Path, $Handler)
+  {
+    if(is_array($Path))
+    {
+      $Page = &$this->Pages;
+      $LastKey = array_pop($Path);
+      foreach($Path as $PathItem)
+      {
+        $Page = &$Page[$PathItem];
+      }
+      if(!is_array($Page)) $Page = array('' => $Page);
+      $Page[$LastKey] = $Handler;
+    } else $this->Pages[$Path] = $Handler;
+  }
+
+  function UnregisterPage($Path)
+  {
+    unset($this->Pages[$Path]);
+  }
+
+  function SearchPage($PathItems, $Pages)
+  {
+    if(count($PathItems) > 0) $PathItem = $PathItems[0];
+      else $PathItem = '';
+    if(array_key_exists($PathItem, $Pages))
+    {
+      if(is_array($Pages[$PathItem]))
+      {
+        array_shift($PathItems);
+        return($this->SearchPage($PathItems, $Pages[$PathItem]));
+      } else return($Pages[$PathItem]);
+    } else return('');
+  }
+
+  function Link($Target)
+  {
+    return($this->BaseURL.$Target);
+  }
+}
+
+class PageMissing extends Page
+{
+  function __construct($System)
+  {
+    parent::__construct($System);
+    $this->ParentClass = '';
+    $this->Title = T('Page not found');
+  }
+
+  function Show()
+  {
+    Header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
+    return('<h3 align="center">'.T('Required page not found'));
+  }
+}
Index: /trunk/Application/DefaultConfig.php
===================================================================
--- /trunk/Application/DefaultConfig.php	(revision 69)
+++ /trunk/Application/DefaultConfig.php	(revision 69)
@@ -0,0 +1,57 @@
+<?php
+
+class DefaultConfig
+{
+  function Get()
+  {
+    $IsDeveloper = in_array($_SERVER['REMOTE_ADDR'], array('127.0.0.1'));
+    return(array
+    (
+        array('Name' => 'SystemPassword', 'Type' => 'PasswordEncoded', 'Default' => '', 'Title' => 'Systémové heslo'),
+        array('Name' => 'Database/Host', 'Type' => 'String', 'Default' => 'localhost', 'Title' => 'Server'),
+        array('Name' => 'Database/User', 'Type' => 'String', 'Default' => 'root', 'Title' => 'Uživatel'),
+        array('Name' => 'Database/Password', 'Type' => 'Password', 'Default' => '', 'Title' => 'Heslo'),
+        array('Name' => 'Database/Database', 'Type' => 'String', 'Default' => 'centrala', 'Title' => 'Databáze'),
+        array('Name' => 'Database/Prefix', 'Type' => 'String', 'Default' => '', 'Title' => 'Prefix'),
+        array('Name' => 'Database/Charset', 'Type' => 'String', 'Default' => 'utf8', 'Title' => 'Znaková sada'),
+        array('Name' => 'Web/Style', 'Type' => 'String', 'Default' => 'new', 'Title' => 'Styl'),
+        array('Name' => 'Web/FormatHTML', 'Type' => 'String', 'Default' => '', 'Title' => 'Formátovat HTML'),
+        array('Name' => 'Web/Charset', 'Type' => 'String', 'Default' => 'utf-8', 'Title' => 'Znaková sada'),
+        array('Name' => 'Web/RootFolder', 'Type' => 'String', 'Default' => '', 'Title' => 'Kořenová složka'),
+        array('Name' => 'Web/Host', 'Type' => 'String', 'Default' => 'localhost', 'Title' => 'Doménové jméno'),
+        array('Name' => 'Web/Title', 'Type' => 'String', 'Default' => 'Síť', 'Title' => 'Titulek'),
+        array('Name' => 'Web/Description', 'Type' => 'String', 'Default' => 'Komunitní počítačová síť', 'Title' => 'Popis'),
+        array('Name' => 'Web/Admin', 'Type' => 'String', 'Default' => 'Admin', 'Title' => 'Jméno správce'),
+        array('Name' => 'Web/AdminEmail', 'Type' => 'String', 'Default' => 'admin@localhost', 'Title' => 'E-mail správce'),
+        array('Name' => 'Web/ErrorLogFile', 'Type' => 'String', 'Default' => 'php_script_error.log', 'Title' => 'Soubor záznamu chyb'),
+        array('Name' => 'Web/WebcamPassword', 'Type' => 'Password', 'Default' => '', 'Title' => 'Heslo web kamery'),
+        array('Name' => 'Web/WebcamRefresh', 'Type' => 'Integer', 'Default' => '5', 'Title' => 'Interval obnovení'),
+        array('Name' => 'Web/UploadFileFolder', 'Type' => 'String', 'Default' => 'files', 'Title' => 'Složka načtených souborů'),
+        array('Name' => 'Web/News/DaysAgo', 'Type' => 'Integer', 'Default' => '30', 'Title' => 'Stáří zobrazovaných aktualit'),
+        array('Name' => 'Web/News/Count', 'Type' => 'Integer', 'Default' => '5', 'Title' => 'Počet zobrazovaných aktualit na skupinu'),
+        array('Name' => 'Web/News/DirectoryId', 'Type' => 'Integer', 'Default' => '1', 'Title' => 'Id adresáře souborů příloh aktualit'),
+        array('Name' => 'Map/GoogleMapsApiKey', 'Type' => 'String', 'Default' => '', 'Title' => 'API google map'),
+        array('Name' => 'Map/DefaultLatitude', 'Type' => 'Float', 'Default' => '49.260422', 'Title' => 'Výchozí pozice na mapě'),
+        array('Name' => 'Map/DefaultLongitude', 'Type' => 'Float', 'Default' => '18.081179', 'Title' => 'Výchozí pozice na mapě'),
+        array('Name' => 'Map/DefaultZoom', 'Type' => 'Float', 'Default' => '15', 'Title' => 'Výchozí přihlížení mapy'),
+        array('Name' => 'Web/ItemsPerPage', 'Type' => 'Integer', 'Default' => '50', 'Title' => 'Položek na stránku'),
+        array('Name' => 'Web/VisiblePagingItems', 'Type' => 'Integer', 'Default' => '20', 'Title' => 'Položek stránkování'),
+        array('Name' => 'Web/FormatHTML', 'Type' => 'Boolean', 'Default' => '0', 'Title' => 'Formátovat výsledný kód'),
+        array('Name' => 'Web/ShowSQLError', 'Type' => 'Boolean', 'Default' => '0', 'Title' => 'Ukazovat SQL chyby'),
+        array('Name' => 'Web/ShowSQLQuery', 'Type' => 'Boolean', 'Default' => '0', 'Title' => 'Ukazovat SQL dotazy'),
+        array('Name' => 'Web/ShowPHPError', 'Type' => 'Boolean', 'Default' => '0', 'Title' => 'Ukazovat PHP chyby'),
+        array('Name' => 'Web/ShowRuntimeInfo', 'Type' => 'Boolean', 'Default' => '0', 'Title' => 'Ukazovat běhové informace'),
+        array('Name' => 'Finance/MainUserId', 'Type' => 'Integer', 'Default' => '1', 'Title' => 'Id hlavního uživatele'),
+        array('Name' => 'Finance/MainSubjectId', 'Type' => 'Integer', 'Default' => '1', 'Title' => 'Id hlavního subjektu'),
+        array('Name' => 'Finance/DirectoryId', 'Type' => 'Integer', 'Default' => '1', 'Title' => 'Id adresáře souborů dokladů'),
+        array('Name' => 'Finance/Rounding', 'Type' => 'Integer', 'Default' => '2', 'Title' => 'Počet desetinných míst zaokrouhlování'),
+        array('Name' => 'MainRouter/HostName', 'Type' => 'String', 'Default' => 'localhost', 'Title' => 'Hlavní brána'),
+        array('Name' => 'MainRouter/UserName', 'Type' => 'String', 'Default' => 'admin', 'Title' => 'Uživatelské jméno'),
+        array('Name' => 'MainRouter/Password', 'Type' => 'Password', 'Default' => '', 'Title' => 'Heslo'),
+        array('Name' => 'MainRouter/InetInterface', 'Type' => 'String', 'Default' => 'ether_wan', 'Title' => 'WAN rozhraní'),
+        array('Name' => 'MainRouter/LocalInterface', 'Type' => 'String', 'Default' => 'ether_lan', 'Title' => 'LAN rozhraní'),
+        array('Name' => 'MainRouter/ConnectTimeout', 'Type' => 'Integer', 'Default' => '5', 'Title' => 'Vypršení času'),
+        array('Name' => 'MainRouter/MangleRuleSubgroupMinPrefix', 'Type' => 'Integer', 'Default' => '28', 'Title' => 'Nejmenší prefix podsítě pro mangle pravidla'),
+    ));
+  }
+}
Index: /trunk/Application/UpdateTrace.php
===================================================================
--- /trunk/Application/UpdateTrace.php	(revision 69)
+++ /trunk/Application/UpdateTrace.php	(revision 69)
@@ -0,0 +1,68 @@
+<?php
+
+function FullInstall($Manager)
+{
+   $Manager->Execute('CREATE TABLE IF NOT EXISTS `SystemVersion` (
+  `Id` int(11) NOT NULL AUTO_INCREMENT,
+  `Revision` int(11) NOT NULL,
+  PRIMARY KEY (`Id`)
+) ENGINE=InnoDB DEFAULT CHARSET=utf8;');
+  $Manager->Execute('INSERT INTO `SystemVersion` (`Id`, `Revision`) VALUES (NULL, 65);');
+  $Manager->Execute('CREATE TABLE IF NOT EXISTS `measure` (
+  `Id` int(11) NOT NULL auto_increment,
+  `Name` varchar(255) collate utf8_general_ci NOT NULL,
+  `Description` varchar(255) collate utf8_general_ci NOT NULL,
+  `Divider` int(11) NOT NULL default 1,
+  `Unit` varchar(16) collate utf8_general_ci NOT NULL,
+  `Continuity` tinyint(1) NOT NULL default 0,
+  `Period` int(11) NOT NULL default 60,
+  `OldName` varchar(32) collate utf8_general_ci NOT NULL,
+  `PermissionView` varchar(255) collate utf8_general_ci NOT NULL default "all",
+  `PermissionAdd` varchar(255) collate utf8_general_ci NOT NULL default "localhost.localdomain",
+  `Info` varchar(255) collate utf8_general_ci NOT NULL,
+  `Enabled` int(11) NOT NULL default 1,
+  `Cumulative` int(11) NOT NULL default 0,
+  `DataTable` varchar(32) collate utf8_general_ci NOT NULL default "data",
+  `DataType` varchar(32) collate utf8_general_ci NOT NULL,
+  PRIMARY KEY  (`Id`)
+) ENGINE=InnoDB  DEFAULT CHARSET=utf8;');
+}
+
+function UpdateTo67($Manager)
+{
+  $Manager->Execute('RENAME TABLE `measure` TO `Measure`;');
+/*
+   $Manager->Execute('CREATE TABLE IF NOT EXISTS `Permission` (
+  `Id` int(11) NOT NULL AUTO_INCREMENT,
+  `Measure` int(11) NOT NULL,
+  `Address` varchar(255) NOT NULL,
+  `Operation` varchar(255) NOT NULL,
+  PRIMARY KEY (`Id`),
+  KEY `Measure` (`Measure`)
+) ENGINE=InnoDB DEFAULT CHARSET=utf8;');
+  $Manager->Execute('ALTER TABLE `Permission` ADD FOREIGN KEY (`Measure`) '.
+  'REFERENCES `Measure`(`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT;');
+  $DbResult = $Manager->Execute('SELECT `Id`, `PermissionAdd` FROM `Measure`');
+  while($DbRow = $DbResult->fetch_assoc())
+  {
+    $Manager->Execute('INSERT INTO `Permission` (`Measure`, `Operation`) VALUES ('.
+	    $DbRow['Id'].', "add");');
+	}
+  $DbResult = $Manager->Execute('SELECT `Id`, `PermissionView` FROM `Measure`');
+  while($DbRow = $DbResult->fetch_assoc())
+  {
+	  $Manager->Execute('INSERT INTO `Permission` (`Measure`, `Operation`) VALUES ('.
+	    $DbRow['Id'].', "view");');
+  }
+  */
+}
+
+class Updates
+{
+  function Get()
+  {
+    return(array(
+      65 => array('Revision' => 67, 'Function' => 'UpdateTo67'),
+    ));
+  }
+}
Index: /trunk/Application/Version.php
===================================================================
--- /trunk/Application/Version.php	(revision 69)
+++ /trunk/Application/Version.php	(revision 69)
@@ -0,0 +1,10 @@
+<?php
+
+// Subversion revision have to be updated always to next revision number
+// before commiting new changes.
+// Database revision have to be updated if database structure is changed
+// and system will need database update.
+
+$Revision = 67;
+$DatabaseRevision = 67;
+$ReleaseTime = strtotime('2016-02-28');
Index: /trunk/Application/View.php
===================================================================
--- /trunk/Application/View.php	(revision 69)
+++ /trunk/Application/View.php	(revision 69)
@@ -0,0 +1,33 @@
+<?php
+
+class BaseView extends View
+{
+  function ShowPage($Content)
+  {
+    global $ReleaseTime, $Revision;
+
+    $Output = '<?xml version="1.0" encoding="'.$this->System->Config['Web']['Charset'].'"?>'."\n".
+    '<!DOCTYPE html>'.
+    '<html>'.
+    '<head>'.
+    '<meta http-equiv="Content-Language" content="cs"/>'.
+    '<meta http-equiv="content-type" content="text/html; charset='.$this->System->Config['Web']['Charset'].'" />'.
+    '<meta name="robots" content="all" />'.
+    '<title>'.$this->System->Config['Web']['Title'].'</title>'.
+    '<link rel="StyleSheet" href="'.$this->System->Link('/style/style.css').'" type="text/css" media="all"/>'.
+    '</head><body>';
+    $Output .= $Content;
+    $Output .= '<br/><div style="text-align: center; font-size: small;">Verze: '.$Revision.' ('.HumanDate($ReleaseTime).')'.
+      ' &nbsp; <a href="http://svn.zdechov.net/trac/statistic/browser/trunk">Zdrojový kód</a> &nbsp; '.
+      '<a href="http://svn.zdechov.net/trac/statistic/log/trunk?verbose=on">Historie změn</a></div>';
+    $Output .= '</body></html>';
+    echo($Output);
+  }
+
+  function GetOutput($Page)
+  {
+    $Output = $this->ShowPage($Page->Show());
+    return($Output);
+  }
+}
+
Index: /trunk/Global.php
===================================================================
--- /trunk/Global.php	(revision 68)
+++ /trunk/Global.php	(revision 69)
@@ -1,11 +1,7 @@
 <?php
 
-include_once('Version.php');
 include_once('Types.php');
 include_once('Classes.php');
 include_once('Packages/Common/Common.php');
-include_once('Measure.php');
-include_once('Application.php');
-include_once('Update.php');
 
 function HumanDate($Time)
@@ -18,26 +14,4 @@
   list($Usec, $Sec) = explode(" ", microtime());
   return ((float)$Usec + (float)$Sec);
-}
-
-function ShowPage($Content)
-{
-  global $Config, $ReleaseTime, $Revision;
-
-  $Output = '<?xml version="1.0" encoding="'.$Config['Web']['Charset'].'"?>'."\n".
-  '<!DOCTYPE html>'.
-  '<html>'.
-  '<head>'.
-  '<meta http-equiv="Content-Language" content="cs"/>'.
-  '<meta http-equiv="content-type" content="text/html; charset='.$Config['Web']['Charset'].'" />'.
-  '<meta name="robots" content="all" />'.
-  '<title>'.$Config['Web']['Title'].'</title>'.
-  '<link rel="StyleSheet" href="style/style.css" type="text/css" media="all"/>'.
-  '</head><body>';
-  $Output .= $Content;
-  $Output .= '<br/><div style="text-align: center; font-size: small;">Verze: '.$Revision.' ('.HumanDate($ReleaseTime).')'.
-    ' &nbsp; <a href="http://svn.zdechov.net/trac/statistic/browser/trunk">Zdrojový kód</a> &nbsp; '.
-    '<a href="http://svn.zdechov.net/trac/statistic/log/trunk?verbose=on">Historie změn</a></div>';
-  $Output .= '</body></html>';
-  echo($Output);
 }
 
@@ -97,2 +71,42 @@
   return($Output);
 }
+
+function ProcessURL()
+{
+  if(array_key_exists('REDIRECT_QUERY_STRING', $_SERVER))
+    $PathString = $_SERVER['REDIRECT_QUERY_STRING'];
+    else $PathString = '';
+  if(substr($PathString, -1, 1) == '/') $PathString = substr($PathString, 0, -1);
+  $PathItems = explode('/', $PathString);
+  if(array_key_exists('REQUEST_URI', $_SERVER) and (strpos($_SERVER['REQUEST_URI'], '?') !== false))
+    $_SERVER['QUERY_STRING'] = substr($_SERVER['REQUEST_URI'], strpos($_SERVER['REQUEST_URI'], '?') + 1);
+    else $_SERVER['QUERY_STRING'] = '';
+  parse_str($_SERVER['QUERY_STRING'], $_GET);
+  return($PathItems);
+}
+
+function GetQueryStringArray($QueryString)
+{
+  $Result = array();
+  $Parts = explode('&', $QueryString);
+  foreach($Parts as $Part)
+  {
+    if($Part != '')
+    {
+      if(!strpos($Part, '=')) $Part .= '=';
+      $Item = explode('=', $Part);
+      $Result[$Item[0]] = $Item[1];
+    }
+  }
+  return($Result);
+}
+
+function SetQueryStringArray($QueryStringArray)
+{
+  $Parts = array();
+  foreach($QueryStringArray as $Index => $Item)
+  {
+    $Parts[] = $Index.'='.$Item;
+  }
+  return(implode('&amp;', $Parts));
+}
Index: /trunk/Graph.php
===================================================================
--- /trunk/Graph.php	(revision 68)
+++ /trunk/Graph.php	(revision 69)
@@ -1,5 +1,5 @@
 <?php
 
-include('Global.php');
+include_once('Application/Core.php');
 
 class MeasureGraph
@@ -216,6 +216,7 @@
 }
 
-$Application = new Application();
-$Application->Start();
-$Graph = new MeasureGraph($this->Database);
+$Core = new Core();
+$Core->ShowPage = false;
+$Core->Run();
+$Graph = new MeasureGraph($Core->Database);
 $Graph->Render();
